###############################################################################
# Copyright 2014 2017 Intel Corporation.
#
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors. The
# Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions. No part of the Material may be used, copied, reproduced, modified,
# published, uploaded, posted, transmitted, distributed or disclosed in any way
# without Intel's prior express written permission.
#
# No license under any patent, copyright or other intellectual property rights
# in the Material is granted to or conferred upon you, either expressly, by
# implication, inducement, estoppel or otherwise. Any license under such
#
# intellectual property rights must be express and approved by Intel in writing.
# Unless otherwise agreed by Intel in writing, you may not remove or alter 
# this notice or any other notice embedded in Materials by Intel or Intel's 
# suppliers or licensors in any way.
###############################################################################


from __future__ import absolute_import
    
# default class for all environments to inherit from
# provide's virtual functions for examples of what must be implemented
# using _BitData to prevent folks from seeing it if they are importing this file
from . bitdata import BitData as _BitData
 
class baseaccess(object):
    # ITP backwards compatibility
    BitData = _BitData
    
    def __init__(self):
        pass
        ## Recommended Code flow is something like this:
        ## create devicelist
        # self.devicelist = device.DeviceList()
        ## create control variable container, likely
        ## this will need a copy of the baseaccess in many cases
        # self.cv = ControlVariables()
        ## This will have all the raw commands available
        ## I am not sure whether to hide/expose this
        ## it will have a link to the devicelist for any lookup's needed
        # self.cmds = Commands()

class ControlVariables(object):
    pass

class Commands(object):
    pass
